function refresh()

	for t=1 to VesselMx step 1
		LogicVessel(t)
	next
	
	;repeat
		;Cls
		game_controls()
		player_controls()
		;render_vessels()
		render_stars()
		player_movement()
		render_player()
		render_stars()
		render_comlink()
		vessel_tracker()
		render_hud()
		;Flip
	;forever
end function

function game_controls()
	
	;Repeat
		thrust=0
		mx#=MouseX()
		my#=MouseY()
		md1=MouseHit(1)
		md2=MouseHit(2)
		md3=MouseHit(3)
		If KeyHit(1) Then End
		If KeyDown(203) Then; counter-clockwise
			frame=frame-1
			If frame<0 Then frame=frame+36
		EndIf
		If KeyDown(205) Then; clockwise
			frame=frame+1
			If frame>35 Then frame=frame-36
		EndIf
		If KeyDown(200) Then; accelerate
			xspd#=xspd#+Sin(frame*10)*accel#
			yspd#=yspd#-Cos(frame*10)*accel#
			thrust=1
		EndIf
		If KeyDown(208) Then; deccelerate
			xspd#=xspd#-Sin(frame*10)*deccel#
			yspd#=yspd#+Cos(frame*10)*deccel#
			thrust=-1
		EndIf
		If KeyHit(74) Then ;comsat -
			comsat=comsat-1
			If comsat<1 Then comsat=32
		EndIf
		If KeyHit(78) Then ;comsat +
			comsat=comsat+1
			If comsat>32 Then comsat=1
		EndIf
		If xspd#>maxspd# Then xspd#=maxspd#
		If xspd#<-maxspd# Then xspd#=-maxspd#
		If yspd#>maxspd# Then yspd#=maxspd#
		If yspd#<-maxspd# Then yspd#=-maxspd#
		x#=x#+xspd#
		y#=y#+yspd#
		;sx#=sx#+xspd#
		;sy#=sy#+yspd#
		sx#=-xspd#*16
		sy#=-yspd#*16
		xd#=xd#-xspd#
		yd#=yd#-yspd#
		starframe=starframe+1
		If starframe>3 Then starframe=0
		If sx#<-shc Then sx#=-shc
		If sx#>shc Then sx#=shc
		If sy#<-160 Then sy#=-160
		If sy#>160 Then sy#=160
		If xd#<-swc Then xd#=xd#+swc
		If xd#>swc Then xd#=xd#-swc
		If yd#<-shc Then yd#=yd#+shc
		If yd#>shc Then yd#=yd#-shc
		for t=1 to vesselMx step 1
			LogicVessel(t)
			
			if obj#(t,objVPace)=0.0 then
				obj#(t,objVPace)=1.0
			endif
			
			objdx#=obj#(t,objVSpdX)
			objdy#=obj#(t,objVSpdY)
			
			objdd#=objdx#^2.0+objdy#^2.0
			
			if objdd#>0.0 then
				objdd#=objdd#^0.5

			;;pace#=objPacePace#(t) ;[!!!]
				obj#(t,objVSpdX)=objdx#/objdd#*obj#(t,objVPace)
				obj#(t,objVSpdY)=objdy#/objdd#*obj#(t,objVPace)
			;elseif obj#(t,objVSpdX)=0 and obj#(t,objVSpdY)=0
				;obj#(t,objVSpdX)=rnd(-3,3)
				;obj#(t,objVSpdY)=rnd(-3,3)
			endif
			
			obj#(t,objVChase)=neartt
			
			obj#(t,objVX)=obj#(t,objVX)+obj#(t,objVSpdX)
			obj#(t,objVY)=obj#(t,objVY)+obj#(t,objVSpdY)
		Next
		;refresh()
	;forever
end function
function player_controls()

	If md1=1 Then
		
		t=comsat
		
		Repeat
			
			t=t+1
			t=((t-1) Mod 32)+1
			
			If t=comsat Then Exit
			
			rx#=obj#(t,objVX)-x#+sx#
			ry#=obj#(t,objVY)-y#+sy#
			
			imgTemp=objSprite(f2i(obj#(t,objVName)),0)
			
			if imgTemp<>0 then
				xr#=ImageWidth(imgTemp)/2
				yr#=ImageHeight(imgTemp)/2
			else
				xr#=32
				yr#=32
			endif

			xxx1=0
			yyy1=0

			If rx#-xr#>swc+imagewidth(imgTemp) or rx#+xr#<-swc-imagewidth(imgTemp) then
				xxx1=1
				rx#=swc
				xr#=16
			EndIf

			If ry#-yr#>shc+imageheight(imgTemp) or ry#+yr#<-shc-imageheight(imgTemp) then
				yyy1=1
				ry#=shc
				yr#=16
			EndIf

			if xxx1=1 and yyy1=1 then

				rx#=swc
				ry#=shc

				xr#=16
				yr#=16

			EndIf
			
			x1#=swc+rx#-xr#
			y1#=shc+ry#-yr#
			x2#=swc+rx#+xr#
			y2#=shc+ry#+yr#
			If mx#>=x1# And mx#<=x2# And my#>=y1# And my#<=y2# Then
				comsat=t
				Exit
			EndIf
		Forever
	EndIf
end function

function render_stars()	

	For star=3 To 1 Step -1
		Draw_Stars stars(star,starframe),star,x#,y#
	Next
end function

function player_movement()
	
	local dt=0
	
	local iw=0
	local ih=0

	local ssx#=0.0
	local ssy#=0.0
	
	local ssx1#=0.0
	local ssy1#=0.0
	
	local ssx2#=0.0
	local ssy2#=0.0
	
	For t=1 To vesselMx step 1
		
		dt=0
		temp=objSprite(f2i(obj#(t,objVName)),0)
		
		if temp<>0 then
			
			iw=imagewidth(temp)
			ih=imageheight(temp)
			
			ssx#=swc+obj#(t,objVX)-x#+sx#
			ssy#=shc+obj#(t,objVY)-y#+sy#

			ssx1#=ssx#+i2f#(iw)/2
			ssx2#=ssx#-i2f#(iw)/2
			
			ssy1#=ssy#+i2f#(ih)/2
			ssy2#=ssy#-i2f#(ih)/2
			
			select true
				
			case ssx1#	<		-	iw												/	2
					dt			=	1
			case ssx2#	>	sw	+	iw												/	2
					dt			=	1
					
			end select
			
			select true
			
			case ssy1#	<		-	ih												/	2
					dt			=	1
					
			case ssy2#	>	sh	+	ih												/	2
					dt			=	1
					
			end select
			
			select true

			case 	dt		=			0
				
				DrawImage temp,	ssx#,	ssy#
			
				color 0,255,0
				
				iw=imagewidth(temp)
				ih=imageheight(temp)
				
				rect ssx#-iw/2,ssy#-ih/2,iw,ih,0

			default
			
				select true
				
				case ssx1#	<		-	iw												/	2
					ssx#	=			imagewidth(objSprite(f2i(obj#(t,objVName)),1))		/	2
					
				case ssx2#	>	sw	+	iw												/	2
					ssx#	=	sw	-	imagewidth(objSprite(f2i(obj#(t,objVName)),1))		/	2
					
				end select
			
				select true
				
				case ssy1#	<		-	ih												/	2
					ssy#	=			imageheight(objSprite(f2i(obj#(t,objVName)),1))	/	2
					
				case ssy2#	>	sh	+	ih												/	2
					ssy#	=	sh	-	imageheight(objSprite(f2i(obj#(t,objVName)),1))	/	2
					
				end select
				
				DrawImage objSprite(f2i(obj#(t,objVName)),1),	ssx#,	ssy#
			
				color 0,255,0
				
				iw=imagewidth(objSprite(f2i(obj#(t,objVName)),1))
				ih=imageheight(objSprite(f2i(obj#(t,objVName)),1))
				
				rect ssx#-iw/2,ssy#-ih/2,iw,ih,0
			
			end select
			
		endif
		
		rx#=obj#(t,objVX)-x#+sx#
		ry#=obj#(t,objVY)-y#+sy#
		
		If rx#<-swc Then rx#=-sw
		If rx#>swc Then rx#=sh
		If ry#<-shc Then ry#=-sh
		If ry#>shc Then ry#=sh
		
		tmptime#=MilliSecs()
		
		brightness#=(tmptime#/3000.0-Int(tmptime#/3000.0))
		brightness#=Abs((brightness#*2.0)-1.0)
		brightness#=f2i(255.0 * brightness#)
		
		;brightness#=brightness#+127.0
		
		Color brightness#,0,0
		If comsat=t Then Color 0,brightness#,0
		If obj#(comsat,5)=t Then Color brightness#,brightness#,0
		
		Text swc+rx#,shc+ry#,objName$(f2i(obj#(t,objVName))),True,True
	
	Next
	
	If thrust=1 Then
		
		Color 255,255,0
		
		x1#=swc+sx#
		y1#=shc+sy#
		x2#=swc+sx#-Sin(frame*10)*128
		y2#=shc+sy#+Cos(frame*10)*128
		
		Line x1#,y1#,x2#,y2#
	
	EndIf
	
	If thrust=-1 Then
		
		Color 255,255,0

		x1#=swc+sx#-Cos(frame*10)*8
		y1#=shc+sy#-Sin(frame*10)*8
		x2#=swc+sx#+Sin(frame*10)*64-Cos(frame*10)*8
		y2#=shc+sy#-Cos(frame*10)*64-Sin(frame*10)*8

		Line x1#,y1#,x2#,y2#

		x1#=swc+sx#+Cos(frame*10)*8
		y1#=shc+sy#+Sin(frame*10)*8
		x2#=swc+sx#+Sin(frame*10)*64+Cos(frame*10)*8
		y2#=shc+sy#-Cos(frame*10)*64+Sin(frame*10)*8

		Line x1#,y1#,x2#,y2#

	EndIf

end function

function render_player()
	
	DrawImage ship(frame),sx#+swc,sy#+shc
end function

function vessel_tracker()

	For t=1 To vesselMx step 1
		If t<>comsat Then
			
			rx#=obj#(t,objVX)-x#+sx#
			ry#=obj#(t,objVY)-y#+sy#
			
			imgTemp=objSprite(f2i(obj#(t,objVName)),0)
			
			if imgTemp<>0 then
				
				xd#=ImageWidth(imgTemp)
				yd#=ImageHeight(imgTemp)
				
				xr#=ImageWidth(imgTemp)/2
				yr#=ImageHeight(imgTemp)/2
				
			else
				
				xd#=64
				yd#=64
				
				xr#=32
				yr#=32
				
			endif
			
			If rx#-xd#>swc-16 Then
				rx#=swc-16
				xr#=16
			EndIf
			
			If rx#+xd#<-swc+16 Then
				rx#=-swc-16
				xr#=16
			EndIf
			
			If ry#-yd#>shc-16 Then
				ry#=shc-16
				yr#=16
			EndIf
			
			If ry#+yd#<-shc+16 Then
				ry#=-shc+16
				yr#=16
			EndIf
			
			x1#=swc+rx#-xr#
			y1#=shc+ry#-yr#
			
			x2#=swc+rx#+xr#
			y2#=shc+ry#+yr#
			
			Color 255,255,255
			Rect x1#,y1#,xr#*2,yr#*2,0
			
		EndIf
	Next
end function
