;Dim FileIn(64)
Function Draw_Stars(image,star,x#,y#)
	scale#=1/2^(star-1)
	dx#=((-x#*scale#/256)-Int(-x#*scale#/256))/scale#*256
	dy#=((-y#*scale#/256)-Int(-y#*scale#/256))/scale#*256
	For ty=-2 To 2 step 1
	For tx=-3 To 3 step 1
		DrawImage image,swc+scale#*dx#+tx*256,shc+scale#*dy#+ty*256
	Next
	Next
End Function
Function RenderStarFields()
	ClsColor 0,0,0
	For star=0 To 16 step 1
		For t=1 To 16 step 1
			starpt(t,0)=Rand(0,255)
			starpt(t,1)=Rand(0,255)
			starpt(t,2)=Rand(128,255)
			starpt(t,3)=Rand(128,255)
			starpt(t,4)=Rand(128,255)
			starpt(t,5)=Rand(0,3)
			starpt(t,6)=Rand(0,3)
			starpt(t,7)=Rand(0,3)
		Next
		For tt=0 To 3 step 1
			stars(star,tt)=CreateImage(256,256)
			Cls
			For t=1 To 16 step 1
				tx=starpt(t,0)
				ty=starpt(t,1)
				r=starpt(t,2)
				g=starpt(t,3)
				b=starpt(t,4)
				tzr=(starpt(t,5)+tt) Mod 4
				tzg=(starpt(t,6)+tt) Mod 4
				tzb=(starpt(t,7)+tt) Mod 4
				dz#=tz/16
				r0=r/1.1^tzr
				g0=g/1.1^tzg
				b0=b/1.1^tzb
				Color r0,g0,b0
				Plot tx,ty
				r1=r/1.2^tzr*0.5
				g1=g/1.2^tzg*0.5
				b1=b/1.2^tzb*0.5
				Color r1,g1,b1
				Plot (tx+1) Mod 256,ty
				Plot (tx+255) Mod 256,ty
				Plot tx,(ty+1) Mod 256
				Plot tx,(ty+255) Mod 256
				r2=r/1.3^tzr*0.25
				g2=g/1.3^tzg*0.25
				b2=b/1.3^tzb*0.25
				Color r2,g2,b2
				Plot (tx+2) Mod 256,ty
				Plot (tx+254) Mod 256,ty
				Plot tx,(ty+2) Mod 256
				Plot tx,(ty+254) Mod 256
				Plot (tx+2) Mod 256,(ty+1) Mod 256
				Plot (tx+2) Mod 256,(ty+255) Mod 256
				Plot (tx+254) Mod 256,(ty+1) Mod 256
				Plot (tx+254) Mod 256,(ty+255) Mod 256
				Plot (tx+1) Mod 256,(ty+2) Mod 256
				Plot (tx+255) Mod 256,(ty+2) Mod 256
				Plot (tx+1) Mod 256,(ty+254) Mod 256
				Plot (tx+255) Mod 256,(ty+254) Mod 256
			Next 
			GrabImage stars(star,tt),0,0
			MaskImage stars(star,tt),0,0,0
		Next
	Next
End Function
