
Function LoadIni(IniFile$)
	IniFileIndex=3
	if len(IniFile$)=0 then IniFile$="globals"
	;validate globals docket
	select false
	case is_File(".\datapack\ini\"+IniFile$+".txt")
		return
	end select
	;open globals docket
	FileIn(IniFileIndex)=OpenFile(".\datapack\ini\"+IniFile$+".txt")
	;while lines are available
	While Not(Eof(FileIn(IniFileIndex)))
		;read line buffer from globals file
		Ini_Buffer$=ReadLine$(FileIn(IniFileIndex))
		;parse line label
		Label$=Prefix$(Ini_Buffer$,":")
		Ini_Buffer$=Suffix$(Ini_Buffer$,":")
		select Label$
	
		case "shipMx"
			shipMx=s2i(Ini_Buffer$)			;
		case "vesselMx"
			vesselMx=s2i(Ini_Buffer$)			;

;name
		case "objVName"
			objVName=s2i(Ini_Buffer$)			;
;x,y
		case "objVX"
			objVX=s2i(Ini_Buffer$)			;
		case "objVY"
			objVY=s2i(Ini_Buffer$)			;
;spdx,spdy
		case "objVSpdX"
			objVSpdX=s2f#(Ini_Buffer$)			;
		case "objVSpdY"
			objVSpdY=s2f#(Ini_Buffer$)			;
;chase
		case "objVChase"
			objVChase=s2f#(Ini_Buffer$)			;
;pace
		case "objVPace"
			objVPace=s2f#(Ini_Buffer$)			;
		case "PaceMx"
			PaceMx=s2i(Ini_Buffer$)			;

		case "accel#"
			accel#=s2f#(Ini_Buffer$)			;0.
		case "b0"
			b0=s2f#(Ini_Buffer$)			;
		case "b1"
			b1=s2f#(Ini_Buffer$)			;
		case "b2"
			b2=s2f#(Ini_Buffer$)			;
		case "b"
			b=s2f#(Ini_Buffer$)			;
		case "brightness#"
			brightness#=s2f#(Ini_Buffer$)			;0.
		case "comsat"
			comsat=s2f#(Ini_Buffer$)			;
		case "deccel#"
			deccel#=s2f#(Ini_Buffer$)			;0.
		case "dz#"
			dz#=s2f#(Ini_Buffer$)			;0.
		case "frame"
			frame=s2f#(Ini_Buffer$)			;
		case "g0"
			g0=s2f#(Ini_Buffer$)			;
		case "g1"
			g1=s2f#(Ini_Buffer$)			;
		case "g2"
			g2=s2f#(Ini_Buffer$)			;
		case "g"
			g=s2f#(Ini_Buffer$)			;
		case "imgTemp"
			imgTemp=s2f#(Ini_Buffer$)			;
		case "maxspd#"
			maxspd#=s2f#(Ini_Buffer$)			;10.
		case "md1"
			md1=s2f#(Ini_Buffer$)			;
		case "md2"
			md2=s2f#(Ini_Buffer$)			;
		case "md3"
			md3=s2f#(Ini_Buffer$)			;
		case "mx#"
			mx#=s2f#(Ini_Buffer$)			;0.
		case "my#"
			my#=s2f#(Ini_Buffer$)			;0.
		case "neartt"
			neartt=s2f#(Ini_Buffer$)			;
		case "objIndex"
			objIndex=s2f#(Ini_Buffer$)			;
		case "objdd#"
			objdd#=s2f#(Ini_Buffer$)			;0.
		case "objdx#"
			objdx#=s2f#(Ini_Buffer$)			;0.
		case "objdy#"
			objdy#=s2f#(Ini_Buffer$)			;0.
		case "pace#"
			pace#=s2f#(Ini_Buffer$)			;0.
		case "r0"
			r0=s2f#(Ini_Buffer$)			;
		case "r1"
			r1=s2f#(Ini_Buffer$)			;
		case "r2"
			r2=s2f#(Ini_Buffer$)			;
		case "r"
			r=s2f#(Ini_Buffer$)			;
		case "rx#"
			rx#=s2f#(Ini_Buffer$)			;0.
		case "ry#"
			ry#=s2f#(Ini_Buffer$)			;0.
		case "star"
			star=s2f#(Ini_Buffer$)			;
		case "starframe"
			starframe=s2f#(Ini_Buffer$)			;
		case "sx#"
			sx#=s2f#(Ini_Buffer$)			;0.
		case "sy#"
			sy#=s2f#(Ini_Buffer$)			;0.
		case "t"
			t=s2f#(Ini_Buffer$)			;
		case "temp"
			temp=s2f#(Ini_Buffer$)			;
		case "thrust"
			thrust=s2f#(Ini_Buffer$)			;
		case "tmptime#"
			tmptime#=s2f#(Ini_Buffer$)			;0.
		case "tt"
			tt=s2f#(Ini_Buffer$)			;
		case "tx"
			tx=s2f#(Ini_Buffer$)			;
		case "ty"
			ty=s2f#(Ini_Buffer$)			;
		case "tz"
			tz=s2i(Ini_Buffer$)			;
		case "tzb"
			tzb=s2i(Ini_Buffer$)			;
		case "tzg"
			tzg=s2i(Ini_Buffer$)			;
		case "tzr"
			tzr=s2i(Ini_Buffer$)			;
		case "x#"
			x#=s2f#(Ini_Buffer$)			;0.
		case "x1#"
			x1#=s2f#(Ini_Buffer$)			;0.
		case "x2#"
			x2#=s2f#(Ini_Buffer$)			;0.
		case "xd#"
			xd#=s2f#(Ini_Buffer$)			;0.
		case "xr#"
			xr#=s2f#(Ini_Buffer$)			;0.
		case "xspd#"
			xspd#=s2f#(Ini_Buffer$)			;0.
		case "y#"
			y#=s2f#(Ini_Buffer$)			;0.
		case "y1#"
			y1#=s2f#(Ini_Buffer$)			;0.
		case "y2#"
			y2#=s2f#(Ini_Buffer$)			;0.
		case "yd#"
			yd#=s2f#(Ini_Buffer$)			;0.
		case "yr#"
			yr#=s2f#(Ini_Buffer$)			;0.
		case "yspd#"
			yspd#=s2f#(Ini_Buffer$)			;0.
		end select
	Wend
		
	CloseFile FileIn(IniFileIndex)
End Function