;/////////////// Load Docket / Manifests ///////////////////
Function LoadVessels(DocketFile$)
	if DocketFile$="" then DocketFile$="manifests"
	LoadDocket(DocketFile$)
End Function
Function LoadDocket(DocketFile$)
	
	if len(DocketFile$)=0 then DocketFile$="manifests"
	;validate docket
	if FileType(".\datapack\manifests\"+DocketFile$+".txt")=0 then
		return
	endif
	;open docket
	FileIn(1)=OpenFile(".\datapack\manifests\"+DocketFile$+".txt")
	;while lines are available
	While Not(Eof(FileIn(1)))
		;read line buffer from docket file
		DocketFile_Buffer$=ReadLine$(FileIn(1))
		;Object Docket Index
		objIndex=int(Prefix$(DocketFile_Buffer$,":"))
		DocketFile_Buffer$=Suffix$(DocketFile_Buffer$,":")
		;Object Docket Class
		objClass$(objIndex)=Prefix$(DocketFile_Buffer$,"/")
		DocketFile_Buffer$=Suffix$(DocketFile_Buffer$,"/")
		;Object Docket Name
		objName$(objIndex)=DocketFile_Buffer$
		;Object Index by Name
		;;objName$(objIndex)
		;;;LoadManifest(objClass$(objIndex)+"\"+objName$(objIndex))
	Wend
	
	CloseFile FileIn(1)
	
	objIndex=0
	
	while objIndex>=0 and objIndex<=ShipMx

		LoadManifest(objClass$(objIndex)+"\"+objName$(objIndex))
		
		objIndex=objIndex+1
		
	Wend
		
End Function
