;/////////// Vessel Logic v3.01 ///////////
Function LogicVessel(t)
		
		select len(objLogic$(obj#(t,objVName)))
		case 0
			return
		end select
		
		neard#=objNearDistance#(t,ndVd)
		neartt=f2i(objNearDistance#(t,ndVtt))

		Select true

		Case objLogic$(obj#(t,objVName))="trooper"

			For tt=1 To VesselMx Step 1
				
				if LogicEncounter(t,tt,1)=tt and t<>tt then

					LogicVesselThisD(t,tt)
					
					If LogicVesselFaceCheck("<",-1) Then

						cancel=False

						LogicVesselLoopTTT(t,tt)
						LogicVesselNearD(tt)
						
					EndIf
				EndIf
				
			Next
		
		Case objLogic$(obj#(t,objVName))="cargo"

			LogicVesselChaseCheck(t)
			
			If LogicVesselNearDistanceCheck("<",t) Then

				obj#(t,objVChase)=0

				For tt=1 To VesselMx Step 1
				
					if LogicEncounter(t,tt,1)=tt and t<>tt then
						
						LogicVesselThisD(t,tt)
						
						If LogicVesselFaceCheck(">",tt) Then

							cancel=False

							LogicVesselLoopTTT(t,tt)
							LogicalVesselNearCheck(t,tt)
							
						EndIf
					EndIf
				
				Next
				
			EndIf

		Case objLogic$(obj#(t,objVName))="miner"

			LogicVesselChaseCheck(t)
			
			If LogicVesselNearDistanceCheck("<",t) Then

				LogicVesselLoopTT(t)
			
			EndIf

		End Select
		
		LogicVesselPace(t)
		
end function

function LogicVesselNearDistanceCheck(d$,t)
	
	select true
	case d$="="
		
		return neard#=objNearDistance#(obj#(t,objVName),ndVdist)
		
	case d$="<"
		
		return neard#<objNearDistance#(obj#(t,objVName),ndVdist)
		
	case d$=">"
		
		return neard#>objNearDistance#(obj#(t,objVName),ndVdist)
		
	end select
	
end function

function LogicVesselFaceCheck(d$,tt)
	
	select true
	case d$="="
		
		return neard#=-1 Or thisd#=neard#
	
	case d$="<"
		
		return neard#=-1 Or thisd#<neard#
	
	case d$=">"
		
		return neard#=-1 Or thisd#>neard#
	
	case right$(d$,2)="!"

		if LogicVesselFaceCheck(left$(d$,1),tt) and cancel=false then
			
			neard#=thisd#
			neartt=tt
			
			return -1
		
		end if

	end select
	
end function

function LogicVesselThisD(t,tt)

	thisd#=(obj#(tt,objVX)-obj#(t,objVX))^2+(obj#(tt,objVY)-obj#(t,objVY))^2
	if thisd#<>0.0 then thisd#=thisd#^0.5

end function

function LogicVesselPace(t)

		pace#=VesselPaceLogic(t,neartt,neard#,pace#)

		obj#(t,objVX)=obj#(t,objVX)+obj#(t,objVSpdX)
		obj#(t,objVY)=obj#(t,objVY)+obj#(t,objVSpdY)

end function

function LogicVesselNearD(tt)
	If neard#=-1 Or thisd#<neard# And cancel=False Then
		neard#=thisd#
		neartt=tt	
	EndIf
end function

Function LogicalVesselNearCheck(t,tt)
	If neard#=-1 Or (thisd#<neard# Or neard#<=objNearDistance#(obj#(t,objVName),ndVdist)) And cancel=False Then
		neard#=thisd#
		neartt=tt
	EndIf
end function

Function LogicVesselChaseCheck(t1)
	
	If obj#(t1,objVChase)>0 Then
		neartt=obj#(t1,objVChase)
		neard#=(obj#(neartt,objVX)-obj#(t1,objVX))^2+(obj#(neartt,objVY)-obj#(t1,objVY))^2
	EndIf
	
end function

Function LogicVesselLoopTTT(t1,t2)
	
	if t1=t2 then return
	
	For t3=1 To VesselMx Step 1
		if LogicEncounter(t1,t3,1)=t2 and t1<>t3 then
			theird#=(obj#(t2,objVX)-obj#(t3,objVX))^2+(obj#(t2,objVY)-obj#(t3,objVY))^.2
			If theird#<thisd# And obj#(t3,objVChase)=t2 Then cancel=True
		EndIf
	Next
	
end function

Function LogicVesselLoopTT(t1)

	For t2=1 To VesselMx Step 1
		if LogicEncounter(t1,t2,1)=t2 and t1<>t2 then
			thisd#=(obj#(t2,objVX)-obj#(t1,objVX))^2+(obj#(t2,objVY)-obj#(t1,objVY))^2
			If neard#=-1 Or thisd#>neard# Then
				neard#=thisd#
				neartt=t2
			EndIf
		EndIf
	Next

End Function

;/////////// Logic Pace I ///////////
Function LogicPace(t,dist0#,pace0#)
	
	PaceIndex=0

	for PaceIndex=0 to 16 step 1
		if f2i(objPaceDistance#(f2i(obj#(t,objVName)),PaceIndex))<>-1 then
			if objdd#>objPaceDistance#(f2i(obj#(t,objVName)),PaceIndex) then
				pace#=objPacePace#(f2i(obj#(t,objVName)),PaceIndex)
				return pace#
			endif
		 endif
	next

	return pace#

	If objdd#>5000 Then
		pace#=10
	ElseIf objdd#>2000 Then
		pace#=6
	ElseIf objdd#>500 Then
		pace#=5
	Else
		pace#=0
	EndIf
	
	return pace#
	
	obj#(t,objVPace)=1.0
	
	repeat
		
		select false
		case PaceIndex<=PaceMx
			exit
		case PaceIndex>=0
			exit
		case objPaceDistance#(f2i(obj#(t,objVName)),PaceIndex)>-1
			exit
		end select
	
		select true
		case dist0#>=objPaceDistance#(f2i(obj#(t,objVName)),PaceIndex)
		
			obj#(t,objVPace)=objPacePace#(f2i(obj#(t,objVName)),PaceIndex)
			
			;exit
						
		end select
		
		PaceIndex=PaceIndex+1
		
	forever
	
end Function
;/////////// Logic Encounter I ///////////
Function LogicEncounter(t1,t2,list)

	select false
	case list>=1 and list<=2
		return 0
	end select
	
	select list
	case 1
		select f2i(obj#(t2,objVName))
		case objEncounters1(f2i(obj#(t1,objVName)),f2i(obj#(t2,objVName)))
			return t2
		default
			return -2
		end select
	case 2
		select f2i(obj#(t2,objVName))
		case objEncounters2(f2i(obj#(t1,objVName)),f2i(obj#(t2,objVName)))
			return t2
		default
			return -2
		end select
	end select
	
End Function

function VesselPaceLogic(t,neartt,neard#,pace#)

	If neard#>0 Then

		objdx#=obj#(neartt,objVX)-obj#(t,objVX)
		objdy#=obj#(neartt,objVY)-obj#(t,objVY)
		objdd#=(objdx#^2+objdy#^2)^.5

		pace#=LogicPace(t,objdd#,pace#)

		obj#(t,objVSpdX)=objdx#/objdd#*pace#
		obj#(t,objVSpdY)=objdy#/objdd#*pace#
		obj#(t,objVChase)=neartt

	EndIf

	return pace#

end function