function monoaxis(x0#,x1#,w#)
	
	select true
	case (x1#-x0#)<0
		return -1
	case (x1#-x0#)>w#
		return 1
	default
		return 0
	end select

end function

function dualaxis(x0#,x1#,y0#,y1#,w#,h#)

	
	repeat
		
		x0#,x1#,y0#,y1#,w#,h#
	forever
	local xaxis=0
	local yaxis=0

	xaxis=monoaxis(x0#,x1#,w#
	yaxis=monoaxis(y0#,y1#,h#

	return "axis[x]:"+i2s$(xaxis)+";axis[y]:"+i2s$(yaxis)

end function

function pythagoras(x0#,y0#,x1#,y1#)
	
	local dx#=0.0
	local dy#=0.0	
	local dd#=0.0
	
	dx#=x1#-x0#
	dy#=y1#-y0#
	
	select false
	case dx#=0.0 and dy#=0.0
		dd#=sqr(dx#^2+dy#^2)
	default
		dd#=0.0
	end select
	
	return "dx:"+f2s$(dx#)+";dy:"+f2s$(dy#)+";dd:"+f2s$(dd#)
	
end function
