
;[ ! Advanced String Support ]
Function strrpos(Haystack$,Needle$)
	Local Offset=Len(Haystack$)
	While Not(Mid$(Haystack$,Offset,Len(Needle$))=Needle$)
		If Offset < 1 Then
			Return 0
		EndIf
		Offset=Offset-1
	Wend
	Return Offset
End Function
Function Suffix$(Haystack$,Needle$)
	local o=Instr(Haystack$,Needle$)
	select false
	case o=0
		Return Mid$(Haystack$,o+Len(Needle$))
	default
		Return ""
	end select
End Function
Function Prefix$(Haystack$,Needle$)
	Return Mid$(Haystack$,1,Instr(Haystack$,Needle$)-1)
End Function
Function is_dir(path$)
	select True
	case FileType(path)=2
		Return True
	default
		Return False
	end select
End Function
Function is_file(path$)
	select True
	case FileType(path)=1
		Return True
	default
		Return False
	end select
End Function

Function s2s$(val$)
	return val$
end function
Function i2s$(val)
	return str$(val)
end function
Function f2s$(val#)
	return str$(val#)
end function

function s2i(val$)
	return int(val$)
end function
function i2i(val)
	return val
end function
function f2i(val#)
	return int(val#)
end function

function s2f#(val$)
	return float#(val$)
end function
function i2f#(val)
	return float#(val)
end function
function f2f#(val#)
	return val#
end function

function AxisLabel$(Buffer$)
	
	local open$="["
	local close$="]"

	local o1=instr(Buffer$,open$)
	local o2=instr(Buffer$,close$)
	
	select true
	case o1>0 and o2=0
		return left$(Buffer$,o1-1)
	case o2>o1
		return left$(Buffer$,o1-1)
	default	
		return Buffer$
	end select
	
end function

function AxisParam$(Buffer$)
	
	local open$="["
	local close$="]"
	
	local o1=instr(Buffer$,open$)
	local o2=instr(Buffer$,close$)
	
	select true
	case o1>0 and o2=0
		return ""
	case o1>0 and o2>o1
		return mid$(Buffer$,o1+len(open$),o2-o1-len(open$))
	default	
		return ""
	end select
	
end function
